/*
 * @(#)MyContentHandler.java    Pzt 19 Nis 2010 14:06:16 EEST
 *
 * Murat iNAN, muratsivas76@gmail.com
 */
/*
*** This program wrote under GNU/General Public License ***

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.
*/

package net.dilmerkezi.xml;

import java.awt.Color;

import javax.swing.*;

import javax.swing.text.JTextComponent;

import org.xml.sax.*;

/**
 * A ContentHandler implementation
 *
 * Murat iNAN, dilmerkezi.net/eng.html
 */
public final class MyContentHandler
        implements ContentHandler
{
    /** Components*/
    private JComponent [] comps;
    
    /** Components count*/
    private int complen;
    
    /** Active text component*/
    private JComponent activeCMP = null;
    
    /** Active component name*/
    private String activeName = "";
    
    /** Active flag*/
    private boolean flag = false;
    
    
    /**
     * @param cmps Components
     * @param cmplen Components count
     */
    public MyContentHandler (
        JComponent [] cmps, int cmplen)
    {
        this.comps = cmps;
        this.complen = cmplen;
    }
    
    public void setDocumentLocator (Locator locator)
    {}
    
    public void startDocument ()
	throws SAXException
    {}
    
    public void endDocument()
	throws SAXException
    {}
    
    public void startPrefixMapping (String prefix, String uri)
	throws SAXException
    {}
    
    public void endPrefixMapping (String prefix)
	throws SAXException
    {}
    
    /**
     * Founds current document
     *
     * @param uri XML path
     * @param localName Tag name
     * @param qName Tag name
     * @param atts tag attributes
     */
    public void startElement (String uri, String localName,
			      String qName, Attributes atts)
	throws SAXException
    {
//        System.out.println (""+localName+"");        
        for (int i=0; i<complen; i++)
        {
            activeCMP = comps [i];
            if (activeCMP != null)
            {
                activeName = activeCMP.getName ();
                //System.out.println (activeName);
            }
            if (activeCMP == null || activeName == null) 
            {
                flag = false;
                continue;
            }
            if (activeName.equalsIgnoreCase (localName))
            {
                flag = true;
                //System.out.println (activeCMP.getName ());
                break;
            }
            else
            {
                flag = false;
            }
        }
        return;
    }
    
    /**
     * Closes flag
     *
     * @param uri XML path
     * @param localName Tag name
     * @param qName Tag name
     */
    public void endElement (String uri, String localName,
			    String qName)
	throws SAXException
    {
        flag = false;
    }
    
    /**
     * Current document set text
     *
     * @param ch Text characters
     * @param starts Text current start point
     * @param end Text current end point
     */
    public void characters (char ch[], int start, int length)
	throws SAXException
    {
        if (activeCMP != null && 
            activeCMP instanceof JTextComponent &&
            flag)
        {
            String str = new String (ch, start, length);
            ((JTextComponent)(activeCMP)).setText (str);
            return;
        }
        
        if (activeCMP != null && 
            activeCMP instanceof JCheckBox &&
            flag)
        {
            String str = new String (ch, start, length);
            JCheckBox box = (JCheckBox)activeCMP;
            if (str.equals ("true")) box.setSelected (true);
            return;
        }
        
        if (activeCMP != null && 
            activeCMP instanceof JComboBox &&
            flag)
        {
            String str = new String (ch, start, length);
            JComboBox combo = (JComboBox)activeCMP;
            int cnt = combo.getItemCount ();
            String cstr = "";
            for (int i=0; i<cnt; i++)
            {
                cstr = (String)combo.getItemAt (i);
                if (cstr.equalsIgnoreCase (str))
                {
                    combo.setSelectedIndex (i);
                    break;
                }
            }
            return;
        }
        
        if (activeCMP != null && 
            activeCMP instanceof JButton &&
            flag)
        {
            String str = new String (ch, start, length);
            JButton b = (JButton)activeCMP;
            int k = 0;
            try
            {
                k = Integer.parseInt (str);
                Color c = new Color (k);
                //System.out.println (c.toString ());
                b.setBackground (c);
            }
            catch (Exception e)
            {
                e.printStackTrace ();
                return;
            }
            return;
        }
        
    }
    
    public void ignorableWhitespace (char ch[], int start, int length)
	throws SAXException
    {}
    
    public void processingInstruction (String target, String data)
	throws SAXException
    {}
    
    public void skippedEntity (String name)
	throws SAXException
    {}
    
}
//class end
